// OctPOUView.h : 
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_OCTPOUVIEW_H__6BC79217_F15B_4025_8E1D_12DBBCEF807C__INCLUDED_)
#define AFX_OCTPOUVIEW_H__6BC79217_F15B_4025_8E1D_12DBBCEF807C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <gl\gl.h>
#include <gl\glu.h>
#include <math.h>

#include "PolygonalMesh.h"
#include "PointSet.h"

class COctPOUView : public CView
{
protected: // 
	COctPOUView();
	DECLARE_DYNCREATE(COctPOUView)

// 
public:
	COctPOUDoc* GetDocument();
	int vertex_N;
	int face_N;

protected:
	HGLRC m_hRC;
	GLdouble eye[3], center[3];
	GLfloat Rx,Ry,Rz;
	int px, py;
	float vx[3], vy[3], vz[3];
	BOOL isLPressed, isRPressed;
	float view_angle;
	float shift_x, shift_y, shift_z;

// 
public:

// 
	// ClassWizard 
	//{{AFX_VIRTUAL(COctPOUView)
	public:
	virtual void OnDraw(CDC* pDC);  // 
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// 
public:
	void drawPointOutOfBox(PointSet *ps, float x1, float x2, float y1, float y2, float z1, float z2);
	void drawConfidence(PointSet* ps);
	void drawPoint(PointSet *ps);
	void wireframe(PolygonalMesh *mesh);
	void smoothShade(PolygonalMesh *mesh);
	void flatShade(PolygonalMesh *mesh);
	void draw();
	void initGL();
	virtual ~COctPOUView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

//  
protected:
	//{{AFX_MSG(COctPOUView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // OctPOUView.cpp 
inline COctPOUDoc* COctPOUView::GetDocument()
   { return (COctPOUDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ 

#endif // !defined(AFX_OCTPOUVIEW_H__6BC79217_F15B_4025_8E1D_12DBBCEF807C__INCLUDED_)
