#ifndef QUADRICB_H
#define QUADRICB_H 

#include <stdio.h>
#include "PointSet.h"
#include "LocalApprox.h"

#define OFF 0.01f

class ImplicitOctCell;

class QuadricB: public LocalApprox{

public:
	float _c0, _cx, _cy, _cz, _cxx, _cyy, _czz, _cxy, _cyz, _czx;

	QuadricB(PointSet* ps, float R, ImplicitOctCell *cell);

	float value(float x, float y, float z){
		return _c0 + _cx*x + _cy*y + _cz*z + 
			   _cxx*x*x + _cyy*y*y + _czz*z*z +
			   _cxy*x*y + _cyz*y*z + _czx*z*x;
	}

	void gradient(float g[], float x, float y, float z){
		g[0] = _cx + 2.0f*_cxx*x + _cxy*y + _czx*z;
		g[1] = _cy + 2.0f*_cyy*y + _cxy*x + _cyz*z;
		g[2] = _cz + 2.0f*_czz*z + _cyz*y + _czx*x;
	}
};

#endif